/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _EZOOM_OPTIONS_H
#define _EZOOM_OPTIONS_H

#include <core/core.h>

class EzoomOptions : public CompOption::Class {
    public:
        enum Options {
            SetZoomArea,
            EnsureVisibility,
            ZoomInButton,
            ZoomInKey,
            ZoomOutButton,
            ZoomOutKey,
            ZoomBoxButton,
            CenterMouseKey,
            ZoomSpecific1Key,
            ZoomSpec1,
            ZoomSpecific2Key,
            ZoomSpec2,
            ZoomSpecific3Key,
            ZoomSpec3,
            SpecTargetFocus,
            LockZoomKey,
            PanLeftKey,
            PanRightKey,
            PanUpKey,
            PanDownKey,
            FitToZoomKey,
            FitToWindowKey,
            ZoomFactor,
            MinimumZoom,
            ZoomMode,
            ScaleMouse,
            ScaleMouseDynamic,
            ScaleMouseStatic,
            HideOriginalMouse,
            RestrainMouse,
            RestrainMargin,
            PanFactor,
            FollowFocus,
            FocusFitWindow,
            AutoscaleMin,
            AlwaysFocusFitWindow,
            FollowFocusDelay,
            Speed,
            Timestep,
            OptionNum
        };

        enum ZoomMode {
            ZoomModeSyncMouse = 0,
            ZoomModePanArea = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        EzoomOptions ();
        virtual ~EzoomOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetSetZoomArea ();
        void optionSetSetZoomAreaInitiate (CompAction::CallBack init);
        void optionSetSetZoomAreaTerminate (CompAction::CallBack term);
        void optionSetSetZoomAreaNotify (ChangeNotify notify);

        CompAction & optionGetEnsureVisibility ();
        void optionSetEnsureVisibilityInitiate (CompAction::CallBack init);
        void optionSetEnsureVisibilityTerminate (CompAction::CallBack term);
        void optionSetEnsureVisibilityNotify (ChangeNotify notify);

        CompAction & optionGetZoomInButton ();
        void optionSetZoomInButtonInitiate (CompAction::CallBack init);
        void optionSetZoomInButtonTerminate (CompAction::CallBack term);
        void optionSetZoomInButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomInKey ();
        void optionSetZoomInKeyInitiate (CompAction::CallBack init);
        void optionSetZoomInKeyTerminate (CompAction::CallBack term);
        void optionSetZoomInKeyNotify (ChangeNotify notify);

        CompAction & optionGetZoomOutButton ();
        void optionSetZoomOutButtonInitiate (CompAction::CallBack init);
        void optionSetZoomOutButtonTerminate (CompAction::CallBack term);
        void optionSetZoomOutButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomOutKey ();
        void optionSetZoomOutKeyInitiate (CompAction::CallBack init);
        void optionSetZoomOutKeyTerminate (CompAction::CallBack term);
        void optionSetZoomOutKeyNotify (ChangeNotify notify);

        CompAction & optionGetZoomBoxButton ();
        void optionSetZoomBoxButtonInitiate (CompAction::CallBack init);
        void optionSetZoomBoxButtonTerminate (CompAction::CallBack term);
        void optionSetZoomBoxButtonNotify (ChangeNotify notify);

        CompAction & optionGetCenterMouseKey ();
        void optionSetCenterMouseKeyInitiate (CompAction::CallBack init);
        void optionSetCenterMouseKeyTerminate (CompAction::CallBack term);
        void optionSetCenterMouseKeyNotify (ChangeNotify notify);

        CompAction & optionGetZoomSpecific1Key ();
        void optionSetZoomSpecific1KeyInitiate (CompAction::CallBack init);
        void optionSetZoomSpecific1KeyTerminate (CompAction::CallBack term);
        void optionSetZoomSpecific1KeyNotify (ChangeNotify notify);

        float optionGetZoomSpec1 ();
        void optionSetZoomSpec1Notify (ChangeNotify notify);

        CompAction & optionGetZoomSpecific2Key ();
        void optionSetZoomSpecific2KeyInitiate (CompAction::CallBack init);
        void optionSetZoomSpecific2KeyTerminate (CompAction::CallBack term);
        void optionSetZoomSpecific2KeyNotify (ChangeNotify notify);

        float optionGetZoomSpec2 ();
        void optionSetZoomSpec2Notify (ChangeNotify notify);

        CompAction & optionGetZoomSpecific3Key ();
        void optionSetZoomSpecific3KeyInitiate (CompAction::CallBack init);
        void optionSetZoomSpecific3KeyTerminate (CompAction::CallBack term);
        void optionSetZoomSpecific3KeyNotify (ChangeNotify notify);

        float optionGetZoomSpec3 ();
        void optionSetZoomSpec3Notify (ChangeNotify notify);

        bool optionGetSpecTargetFocus ();
        void optionSetSpecTargetFocusNotify (ChangeNotify notify);

        CompAction & optionGetLockZoomKey ();
        void optionSetLockZoomKeyInitiate (CompAction::CallBack init);
        void optionSetLockZoomKeyTerminate (CompAction::CallBack term);
        void optionSetLockZoomKeyNotify (ChangeNotify notify);

        CompAction & optionGetPanLeftKey ();
        void optionSetPanLeftKeyInitiate (CompAction::CallBack init);
        void optionSetPanLeftKeyTerminate (CompAction::CallBack term);
        void optionSetPanLeftKeyNotify (ChangeNotify notify);

        CompAction & optionGetPanRightKey ();
        void optionSetPanRightKeyInitiate (CompAction::CallBack init);
        void optionSetPanRightKeyTerminate (CompAction::CallBack term);
        void optionSetPanRightKeyNotify (ChangeNotify notify);

        CompAction & optionGetPanUpKey ();
        void optionSetPanUpKeyInitiate (CompAction::CallBack init);
        void optionSetPanUpKeyTerminate (CompAction::CallBack term);
        void optionSetPanUpKeyNotify (ChangeNotify notify);

        CompAction & optionGetPanDownKey ();
        void optionSetPanDownKeyInitiate (CompAction::CallBack init);
        void optionSetPanDownKeyTerminate (CompAction::CallBack term);
        void optionSetPanDownKeyNotify (ChangeNotify notify);

        CompAction & optionGetFitToZoomKey ();
        void optionSetFitToZoomKeyInitiate (CompAction::CallBack init);
        void optionSetFitToZoomKeyTerminate (CompAction::CallBack term);
        void optionSetFitToZoomKeyNotify (ChangeNotify notify);

        CompAction & optionGetFitToWindowKey ();
        void optionSetFitToWindowKeyInitiate (CompAction::CallBack init);
        void optionSetFitToWindowKeyTerminate (CompAction::CallBack term);
        void optionSetFitToWindowKeyNotify (ChangeNotify notify);

        float optionGetZoomFactor ();
        void optionSetZoomFactorNotify (ChangeNotify notify);

        float optionGetMinimumZoom ();
        void optionSetMinimumZoomNotify (ChangeNotify notify);

        int optionGetZoomMode ();
        void optionSetZoomModeNotify (ChangeNotify notify);

        bool optionGetScaleMouse ();
        void optionSetScaleMouseNotify (ChangeNotify notify);

        bool optionGetScaleMouseDynamic ();
        void optionSetScaleMouseDynamicNotify (ChangeNotify notify);

        float optionGetScaleMouseStatic ();
        void optionSetScaleMouseStaticNotify (ChangeNotify notify);

        bool optionGetHideOriginalMouse ();
        void optionSetHideOriginalMouseNotify (ChangeNotify notify);

        bool optionGetRestrainMouse ();
        void optionSetRestrainMouseNotify (ChangeNotify notify);

        int optionGetRestrainMargin ();
        void optionSetRestrainMarginNotify (ChangeNotify notify);

        float optionGetPanFactor ();
        void optionSetPanFactorNotify (ChangeNotify notify);

        bool optionGetFollowFocus ();
        void optionSetFollowFocusNotify (ChangeNotify notify);

        bool optionGetFocusFitWindow ();
        void optionSetFocusFitWindowNotify (ChangeNotify notify);

        float optionGetAutoscaleMin ();
        void optionSetAutoscaleMinNotify (ChangeNotify notify);

        bool optionGetAlwaysFocusFitWindow ();
        void optionSetAlwaysFocusFitWindowNotify (ChangeNotify notify);

        int optionGetFollowFocusDelay ();
        void optionSetFollowFocusDelayNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
EzoomOptions::optionGetSetZoomArea ()
{
    return mOptions[EzoomOptions::SetZoomArea].value ().action ();
}

inline void
EzoomOptions::optionSetSetZoomAreaInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::SetZoomArea].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetSetZoomAreaTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::SetZoomArea].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetSetZoomAreaNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::SetZoomArea] = notify;
}

inline CompAction &
EzoomOptions::optionGetEnsureVisibility ()
{
    return mOptions[EzoomOptions::EnsureVisibility].value ().action ();
}

inline void
EzoomOptions::optionSetEnsureVisibilityInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::EnsureVisibility].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetEnsureVisibilityTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::EnsureVisibility].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetEnsureVisibilityNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::EnsureVisibility] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomInButton ()
{
    return mOptions[EzoomOptions::ZoomInButton].value ().action ();
}

inline void
EzoomOptions::optionSetZoomInButtonInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomInButton].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomInButtonTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomInButton].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomInButtonNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomInButton] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomInKey ()
{
    return mOptions[EzoomOptions::ZoomInKey].value ().action ();
}

inline void
EzoomOptions::optionSetZoomInKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomInKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomInKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomInKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomInKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomInKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomOutButton ()
{
    return mOptions[EzoomOptions::ZoomOutButton].value ().action ();
}

inline void
EzoomOptions::optionSetZoomOutButtonInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomOutButton].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomOutButtonTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomOutButton].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomOutButtonNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomOutButton] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomOutKey ()
{
    return mOptions[EzoomOptions::ZoomOutKey].value ().action ();
}

inline void
EzoomOptions::optionSetZoomOutKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomOutKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomOutKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomOutKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomOutKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomOutKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomBoxButton ()
{
    return mOptions[EzoomOptions::ZoomBoxButton].value ().action ();
}

inline void
EzoomOptions::optionSetZoomBoxButtonInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomBoxButton].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomBoxButtonTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomBoxButton].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomBoxButtonNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomBoxButton] = notify;
}

inline CompAction &
EzoomOptions::optionGetCenterMouseKey ()
{
    return mOptions[EzoomOptions::CenterMouseKey].value ().action ();
}

inline void
EzoomOptions::optionSetCenterMouseKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::CenterMouseKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetCenterMouseKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::CenterMouseKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetCenterMouseKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::CenterMouseKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomSpecific1Key ()
{
    return mOptions[EzoomOptions::ZoomSpecific1Key].value ().action ();
}

inline void
EzoomOptions::optionSetZoomSpecific1KeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomSpecific1Key].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomSpecific1KeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomSpecific1Key].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomSpecific1KeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomSpecific1Key] = notify;
}

inline float
EzoomOptions::optionGetZoomSpec1 ()
{
    return mOptions[EzoomOptions::ZoomSpec1].value ().f ();
}

inline void
EzoomOptions::optionSetZoomSpec1Notify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomSpec1] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomSpecific2Key ()
{
    return mOptions[EzoomOptions::ZoomSpecific2Key].value ().action ();
}

inline void
EzoomOptions::optionSetZoomSpecific2KeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomSpecific2Key].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomSpecific2KeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomSpecific2Key].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomSpecific2KeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomSpecific2Key] = notify;
}

inline float
EzoomOptions::optionGetZoomSpec2 ()
{
    return mOptions[EzoomOptions::ZoomSpec2].value ().f ();
}

inline void
EzoomOptions::optionSetZoomSpec2Notify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomSpec2] = notify;
}

inline CompAction &
EzoomOptions::optionGetZoomSpecific3Key ()
{
    return mOptions[EzoomOptions::ZoomSpecific3Key].value ().action ();
}

inline void
EzoomOptions::optionSetZoomSpecific3KeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::ZoomSpecific3Key].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetZoomSpecific3KeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::ZoomSpecific3Key].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetZoomSpecific3KeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomSpecific3Key] = notify;
}

inline float
EzoomOptions::optionGetZoomSpec3 ()
{
    return mOptions[EzoomOptions::ZoomSpec3].value ().f ();
}

inline void
EzoomOptions::optionSetZoomSpec3Notify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomSpec3] = notify;
}

inline bool
EzoomOptions::optionGetSpecTargetFocus ()
{
    return mOptions[EzoomOptions::SpecTargetFocus].value ().b ();
}

inline void
EzoomOptions::optionSetSpecTargetFocusNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::SpecTargetFocus] = notify;
}

inline CompAction &
EzoomOptions::optionGetLockZoomKey ()
{
    return mOptions[EzoomOptions::LockZoomKey].value ().action ();
}

inline void
EzoomOptions::optionSetLockZoomKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::LockZoomKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetLockZoomKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::LockZoomKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetLockZoomKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::LockZoomKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetPanLeftKey ()
{
    return mOptions[EzoomOptions::PanLeftKey].value ().action ();
}

inline void
EzoomOptions::optionSetPanLeftKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::PanLeftKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetPanLeftKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::PanLeftKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetPanLeftKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::PanLeftKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetPanRightKey ()
{
    return mOptions[EzoomOptions::PanRightKey].value ().action ();
}

inline void
EzoomOptions::optionSetPanRightKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::PanRightKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetPanRightKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::PanRightKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetPanRightKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::PanRightKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetPanUpKey ()
{
    return mOptions[EzoomOptions::PanUpKey].value ().action ();
}

inline void
EzoomOptions::optionSetPanUpKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::PanUpKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetPanUpKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::PanUpKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetPanUpKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::PanUpKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetPanDownKey ()
{
    return mOptions[EzoomOptions::PanDownKey].value ().action ();
}

inline void
EzoomOptions::optionSetPanDownKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::PanDownKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetPanDownKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::PanDownKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetPanDownKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::PanDownKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetFitToZoomKey ()
{
    return mOptions[EzoomOptions::FitToZoomKey].value ().action ();
}

inline void
EzoomOptions::optionSetFitToZoomKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::FitToZoomKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetFitToZoomKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::FitToZoomKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetFitToZoomKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::FitToZoomKey] = notify;
}

inline CompAction &
EzoomOptions::optionGetFitToWindowKey ()
{
    return mOptions[EzoomOptions::FitToWindowKey].value ().action ();
}

inline void
EzoomOptions::optionSetFitToWindowKeyInitiate (CompAction::CallBack init)
{
    mOptions[EzoomOptions::FitToWindowKey].value ().action ().setInitiate (init);
}

inline void
EzoomOptions::optionSetFitToWindowKeyTerminate (CompAction::CallBack term)
{
    mOptions[EzoomOptions::FitToWindowKey].value ().action ().setTerminate (term);
}

inline void
EzoomOptions::optionSetFitToWindowKeyNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::FitToWindowKey] = notify;
}

inline float
EzoomOptions::optionGetZoomFactor ()
{
    return mOptions[EzoomOptions::ZoomFactor].value ().f ();
}

inline void
EzoomOptions::optionSetZoomFactorNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomFactor] = notify;
}

inline float
EzoomOptions::optionGetMinimumZoom ()
{
    return mOptions[EzoomOptions::MinimumZoom].value ().f ();
}

inline void
EzoomOptions::optionSetMinimumZoomNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::MinimumZoom] = notify;
}

inline int
EzoomOptions::optionGetZoomMode ()
{
    return mOptions[EzoomOptions::ZoomMode].value ().i ();
}

inline void
EzoomOptions::optionSetZoomModeNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ZoomMode] = notify;
}

inline bool
EzoomOptions::optionGetScaleMouse ()
{
    return mOptions[EzoomOptions::ScaleMouse].value ().b ();
}

inline void
EzoomOptions::optionSetScaleMouseNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ScaleMouse] = notify;
}

inline bool
EzoomOptions::optionGetScaleMouseDynamic ()
{
    return mOptions[EzoomOptions::ScaleMouseDynamic].value ().b ();
}

inline void
EzoomOptions::optionSetScaleMouseDynamicNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ScaleMouseDynamic] = notify;
}

inline float
EzoomOptions::optionGetScaleMouseStatic ()
{
    return mOptions[EzoomOptions::ScaleMouseStatic].value ().f ();
}

inline void
EzoomOptions::optionSetScaleMouseStaticNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::ScaleMouseStatic] = notify;
}

inline bool
EzoomOptions::optionGetHideOriginalMouse ()
{
    return mOptions[EzoomOptions::HideOriginalMouse].value ().b ();
}

inline void
EzoomOptions::optionSetHideOriginalMouseNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::HideOriginalMouse] = notify;
}

inline bool
EzoomOptions::optionGetRestrainMouse ()
{
    return mOptions[EzoomOptions::RestrainMouse].value ().b ();
}

inline void
EzoomOptions::optionSetRestrainMouseNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::RestrainMouse] = notify;
}

inline int
EzoomOptions::optionGetRestrainMargin ()
{
    return mOptions[EzoomOptions::RestrainMargin].value ().i ();
}

inline void
EzoomOptions::optionSetRestrainMarginNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::RestrainMargin] = notify;
}

inline float
EzoomOptions::optionGetPanFactor ()
{
    return mOptions[EzoomOptions::PanFactor].value ().f ();
}

inline void
EzoomOptions::optionSetPanFactorNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::PanFactor] = notify;
}

inline bool
EzoomOptions::optionGetFollowFocus ()
{
    return mOptions[EzoomOptions::FollowFocus].value ().b ();
}

inline void
EzoomOptions::optionSetFollowFocusNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::FollowFocus] = notify;
}

inline bool
EzoomOptions::optionGetFocusFitWindow ()
{
    return mOptions[EzoomOptions::FocusFitWindow].value ().b ();
}

inline void
EzoomOptions::optionSetFocusFitWindowNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::FocusFitWindow] = notify;
}

inline float
EzoomOptions::optionGetAutoscaleMin ()
{
    return mOptions[EzoomOptions::AutoscaleMin].value ().f ();
}

inline void
EzoomOptions::optionSetAutoscaleMinNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::AutoscaleMin] = notify;
}

inline bool
EzoomOptions::optionGetAlwaysFocusFitWindow ()
{
    return mOptions[EzoomOptions::AlwaysFocusFitWindow].value ().b ();
}

inline void
EzoomOptions::optionSetAlwaysFocusFitWindowNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::AlwaysFocusFitWindow] = notify;
}

inline int
EzoomOptions::optionGetFollowFocusDelay ()
{
    return mOptions[EzoomOptions::FollowFocusDelay].value ().i ();
}

inline void
EzoomOptions::optionSetFollowFocusDelayNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::FollowFocusDelay] = notify;
}

inline float
EzoomOptions::optionGetSpeed ()
{
    return mOptions[EzoomOptions::Speed].value ().f ();
}

inline void
EzoomOptions::optionSetSpeedNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::Speed] = notify;
}

inline float
EzoomOptions::optionGetTimestep ()
{
    return mOptions[EzoomOptions::Timestep].value ().f ();
}

inline void
EzoomOptions::optionSetTimestepNotify (EzoomOptions::ChangeNotify notify)
{
    mNotify[EzoomOptions::Timestep] = notify;
}



#endif
